import random

# Define the number of trips
num_trips = 50

# Define the possible bus stops
bus_stops = [
    {'id': 'bs_0', 'lane': 'E9_0', 'startPos': 115.55, 'endPos': 125.55},
    {'id': 'bs_1', 'lane': '-E6_0', 'startPos': 188.12, 'endPos': 198.12},
    {'id': 'bs_2', 'lane': '-E8_0', 'startPos': 45.12, 'endPos': 55.12}
]

# Open the XML file for writing
with open('additional/bus/bus_trips.add.xml', 'w') as f:
    # Write the XML header
    f.write('<?xml version="1.0" encoding="UTF-8"?>\n')
    f.write('<additional xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" '
            'xsi:noNamespaceSchemaLocation="http://sumo.dlr.de/xsd/additional_file.xsd">\n')
    f.write(f"\n")

    # Define Vehicle Types
    f.write(
        f"\t<vType id=\"short_distance\" vClass=\"bus\" accel=\"2.6\" decel=\"4.5\" sigma=\"0.5\" length=\"12\" "
        f"minGap=\"3\" maxSpeed=\"9.72\"/>\n")
    f.write(
        f"\t<vType id=\"long_distance\" vClass=\"bus\" accel=\"2.6\" decel=\"4.5\" sigma=\"0.5\" length=\"12\" "
        f"minGap=\"3\" maxSpeed=\"12.5\"/>\n")
    f.write(
        f"\t<vType id=\"other\" vClass=\"bus\" accel=\"2.6\" decel=\"4.5\" sigma=\"0.5\" length=\"12\" minGap=\"3\" "
        f"maxSpeed=\"12.5\"/>\n")

    f.write(f"\n")

    # Generate bus trips randomly
    for i in range(1, num_trips + 1):
        trip_id = f'BUS_{i}'  # Generate trip ID
        trip_type = random.choice(['short_distance', 'long_distance', 'other'])  # Randomly select trip type
        depart_time = random.randint(0, 3600)  # Randomly select departure time between 0 and 3600 seconds
        stop = random.choice(bus_stops)  # Randomly select bus stop
        duration = random.randint(1, 15)  # Generate random duration between 1 and 15
        f.write(f'\t<trip id="{trip_id}" type="{trip_type}" depart="{depart_time}" from="-E8" to="E9">\n')
        f.write(f'\t\t<stop busStop="{stop["id"]}" duration="{duration}"/>\n')
        f.write('\t</trip>\n')

    # Write the closing tag
    f.write('</additional>\n')



