# 1. Import required libraries
import subprocess
import os
import sys

# 2. Activating BPL
if 'SUMO_HOME' in os.environ:
    tools = os.path.join(os.environ['SUMO_HOME'], 'tools')
    sys.path.append(tools)
else:
    sys.exit("please declare environment variable 'SUMO_HOME'")

import traci.constants

# 2.1. Import libsumo
sumoCmd = ["sumo-gui", "-c", "test_network_traci.sumocfg", "--start"]

bus_lane = ['-E8_0', '-E6_0', 'E9_0']

# 2.2. Start Traci
traci.start(sumoCmd)

print("Starting SUMO")

# 2.3. Loop for simulation steps
bpl_time = 0
while traci.simulation.getMinExpectedNumber() > 0:

    traci.simulationStep()

    if 0 < bpl_time < 8000:
        for lane_ in bus_lane:
            traci.lane.setAllowed(lane_, ['bus'])
    else:
        for lane_ in bus_lane:
            traci.lane.setAllowed(lane_, ['all'])
    bpl_time = bpl_time + 1

# 2.4. Close Traci
sys.stdout.flush()
traci.close()

# 3. Obtaining stop_output
# 3.1. Run the simulation without opening GUI and obtaining the StopOutput
run_sumo_no_gui = "sumo -c test_network_traci.sumocfg " \
                  "--stop-output stop_output/stop_output_traci.xml" \

subprocess.run(run_sumo_no_gui, shell=True)

# 3.2. Convert the generated edge data output xml file to csv
xml2csv_call = """python "%SUMO_HOME%\\tools\\xml\\xml2csv.py "\
                  stop_output/stop_output_traci.xml -s , \
               """
subprocess.run(xml2csv_call, shell=True)
